from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, String, Directory, Boolean, Float, Int

Agat_Convert_Sp_Gxf2Gxf_Pl_V0_1_0 = CommandToolBuilder(tool="agat_convert_sp_gxf2gxf.pl", base_command=["agat_convert_sp_gxf2gxf.pl"], inputs=[ToolInput(tag="in_gff", input_type=File(optional=True), prefix="--gff", doc=InputDocumentation(doc="Input GTF/GFF file.")), ToolInput(tag="in_ct", input_type=String(optional=True), prefix="--ct", doc=InputDocumentation(doc="When the features do not have Parent/ID relationships, the\nparser will try to group features using a common/shared\nattribute (i.e. a locus tag.). By default locus_tag and gene_id.\nYou can replace the default common/shared attributes by\nproviding your own(s) using this option. Use comma separated\nlist when providing several.")), ToolInput(tag="in_expose", input_type=Directory(optional=True), prefix="--expose", doc=InputDocumentation(doc="If you want to see, add or modified the feature relationships\nyou will have to use this option. It will copy past in you\nworking directory the json files used to define the relation\nbetween feature types and their level organisation. Typical\nlevel organisation: Level1 => gene; Level2 => mRNA; level3 =>\nexon,cds,utrs If you get warning from the Omniscient parser that\na feature relationship is not defined, you can provide\ninformation about it within the exposed json files. Indeed, if\nthe json files exists in your working directory, they will be\nused by default.")), ToolInput(tag="in_merge_loci", input_type=File(optional=True), prefix="--merge_loci", doc=InputDocumentation(doc="Merge loci parameter, default deactivated. You turn on the\nparameter if you want to merge loci into one locus when they\noverlap. (at CDS level for mRNA, at exon level for other level2\nfeatures. Strand has to be the same). Prokaryote can have\noverlaping loci so it should not use it for prokaryote\nannotation. In eukaryote, loci rarely overlap. Overlaps could be\ndue to error in the file, mRNA can be merged under the same\nparent gene if you acticate the option.")), ToolInput(tag="in_verbose_option_modify", input_type=Boolean(optional=True), prefix="-v", doc=InputDocumentation(doc="Verbose option. To modify verbosity. Default is 1. 0 is quiet, 2\nand 3 are increasing verbosity.")), ToolInput(tag="in_no_check", input_type=String(optional=True), prefix="--no_check", doc=InputDocumentation(doc="To deacticate all check that can be performed by the parser (e.g\nfixing UTR, exon, coordinates etc...)")), ToolInput(tag="in_debug", input_type=String(optional=True), prefix="--debug", doc=InputDocumentation(doc="debug purpose")), ToolInput(tag="in_output", input_type=File(optional=True), prefix="--output", doc=InputDocumentation(doc="Output GFF file. If no output file is specified, the output will\nbe written to STDOUT.")), ToolInput(tag="in_gff_version_input", input_type=Float(optional=True), prefix="--gff_version_input", doc=InputDocumentation(doc="If you don't want to use the autodection of the gff/gft version\nyou give as input, you can force the tool to use the parser of\nthe gff version you decide to use: 1,2,2.5 or 3. Remind: 2.5 is\nsuposed to be gtf.")), ToolInput(tag="in_gff_version_output", input_type=Float(optional=True), prefix="--gff_version_output", doc=InputDocumentation(doc="If you don't want to use the autodection of the gff/gft version\nyou give as input, you can force the tool to use the parser of\nthe gff version you decide to use: 1,2,2.5 or 3. Remind: 2.5 is\nsuposed to be gtf.")), ToolInput(tag="in_agat_convert_sp_gxftwogxfdotpl", input_type=Int(), position=0, doc=InputDocumentation(doc="Description:"))], outputs=[ToolOutput(tag="out_output", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output", type_hint=File()), doc=OutputDocumentation(doc="Output GFF file. If no output file is specified, the output will\nbe written to STDOUT."))], container="quay.io/biocontainers/agat:0.5.1--pl526r35_0", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Agat_Convert_Sp_Gxf2Gxf_Pl_V0_1_0().translate("wdl")

